<?php
require_once(PATH_tslib . 'class.tslib_pibase.php');
require_once(PATH_t3lib . 'class.t3lib_tcemain.php');

class tx_immoscout2ttnews_ttnewshooks extends tslib_pibase {

	/**
 	 * This method is called by a hook in tt_news
	 *
	 * @param object  $pObj: Reference to the parent object (tx_ttnews)
	 * @return string Content for new code
	 */
	public function extraCodesProcessor(&$pObj) {
		if($pObj->config['code'] == 'SINGLE_IMMOSCOUT' && $pObj->tt_news_uid) {
			// get news record
			$row = $GLOBALS['TYPO3_DB']->exec_SELECTgetSingleRow(
				'immoscout_data',
				'tt_news',
				'uid = ' . $pObj->tt_news_uid
			);
			// display default SINGLE template if news record does not contain any immobilienscout24 data
			if(!$row['immoscout_data']) {
				$pObj->theCode = 'SINGLE';
			}
			return $pObj->displaySingle();
		}
	}

	function extraItemMarkerProcessor($markerArray, $row, $lConf, $pObj) {
		$this->pObj = $pObj;
		$this->markerArray = $markerArray;
		$this->defaultKey = 'IMMOSCOUT';
		
		$immoscoutData = json_decode($row['immoscout_data']);

		$this->markerArray['###' . $this->defaultKey . '_REALESTATETYPE###'] = $pObj->pi_getLL('immoscout_realestatetype_' . $row['_immoscout_realestatetype']);
		$this->extractImmoscoutData($immoscoutData);

		// fill LL_* markers
		/*foreach($pObj->renderMarkers as $k => $v) {
			$exploded = explode('_', $k);
			if(is_array($exploded) && $exploded[0] == 'LL') {
				$this->markerArray[$k] = ;
			}
		}*/

		return $this->markerArray;
	}

	/**
	 * Extract data from immoscout object an store it into the marker array
	 *
	 * @param mixed $data
	 * @param string $keyMarkerArray: (optional) Key for marker array
	 */
	function extractImmoscoutData($data, $key, $keyMarkerArray = NULL) {
		if(is_null($keyMarkerArray)) {
			$keyMarkerArray = $this->defaultKey;
		}
		if(is_array($data) || is_object($data)) {
			foreach($data as $k => $v) {
				$this->extractImmoscoutData($v, $k, $keyMarkerArray . '_' . preg_replace('/[^a-zA-Z0-9_]/u', '', $k));
				#$extracted['###' . $keyMarkerArray . strtoupper($k) . '###'] = $v;
			}
		} else {
			$this->markerArray['###' . strtoupper($keyMarkerArray) . '###'] = $this->pObj->cObj->stdWrap($data, $this->pObj->conf['immoscoutConf.'][$key . '.']);
		}
	}

	/**
	 * Transform an object into an array
	 *
	 * @param mixed $data
	 */
	/*function object2array($data) {
		$array = array();
		$_arr = is_object($data) ? get_object_vars($data) : $data;
		foreach($_arr as $k => $v) {
			$v = (is_array($v) || is_object($v)) ? $this->object2array($v) : $v;
			$array[$k] = $v;
		}
		return $array;
	}*/
}
?>