<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2012 Sven Burkert <bedienung@sbtheke.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

unset($MCONF);
require_once('conf.php');
require_once($BACK_PATH . 'init.php');
require_once($BACK_PATH . 'template.php');

$LANG->includeLLFile('EXT:immoscout2ttnews/locallang.xml');
require_once(PATH_t3lib . 'class.t3lib_scbase.php');
$BE_USER->modAccess($MCONF, 1);

/**
 * Module 'mod1' for the 'immoscout2ttnews' extension.
 *
 * @author Sven Burkert <bedienung@sbtheke.de>
 * @package TYPO3
 * @subpackage tx_immoscout2ttnews_module1
 */
class tx_immoscout2ttnews_module1 extends t3lib_SCbase {

	public function init()	{
		global $BE_USER, $LANG, $BACK_PATH, $TCA_DESCR, $TCA, $CLIENT, $TYPO3_CONF_VARS;
		parent::init();
		if(intval($this->id) === 0) {
			$this->id = t3lib_div::_GET('pid');
		}
	}

	/**
	 * Main method of be module
	 * Generates header and module menu
	 *
	 * @return	void
	 */
	public function main()	{
		global $BE_USER, $LANG, $BACK_PATH, $TCA_DESCR, $TCA, $CLIENT, $TYPO3_CONF_VARS;

		$PATH_TYPO3 = t3lib_div::getIndpEnv('TYPO3_SITE_URL') . 'typo3/';

		if($BE_USER->user['admin']) {
			$this->extConf = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['immoscout2ttnews']);

			// load SDK
			require_once(t3lib_extMgm::extPath('immoscout2ttnews') . 'Immocaster/Sdk.php');
			// Verbinden
			$oImmocaster = Immocaster_Sdk::getInstance(
				'is24',
				$this->extConf['basic.']['key'],
				$this->extConf['basic.']['secret']
			);

			// use cUrl
			if($GLOBALS['TYPO3_CONF_VARS']['SYS']['curlUse'] == 1) {
				$oImmocaster->setReadingType('curl');
			}

			// work on live
			if($this->extConf['basic.']['live']) {
				$oImmocaster->setRequestUrl('live');
			}

			// get data as JSON (instead XML)
			$oImmocaster->setContentResultType('json');

			// connect to DB
			$oImmocaster->setDataStorage(array(
				'mysql',
				TYPO3_db_host,
				TYPO3_db_username,
				TYPO3_db_password,
				TYPO3_db
			));
			#var_dump($oImmocaster->oDataStorage->getApplicationToken());exit;

			// is there another way to check that user has authenticated application?
			if(!$oImmocaster->oDataStorage->getApplicationToken()) {
				$aParameter = array(
					'callback_url' => t3lib_div::getIndpEnv('TYPO3_REQUEST_HOST') . '/typo3/mod.php?M=tools_em&CMD[showExt]=immoscout2ttnews&SET[singleDetails]=info',
					'verifyApplication' => true
				);
				if($oImmocaster->getAccess($aParameter)) {
					echo '<b style="color:green;">' . $LANG->getLL('extConf.registered') . '</b>';
				}
			}
			echo '<b style="color:green;">' . $LANG->getLL('extConf.authenticated') . '</b>';

			/*$aParameter = array(
				'callback_url' => t3lib_div::getIndpEnv('TYPO3_REQUEST_HOST') . '/typo3/mod.php?M=tools_em&CMD[showExt]=immoscout2ttnews&SET[singleDetails]=info',
				'verifyApplication' => true
			);
			if($oImmocaster->getAccess($aParameter)) {
				echo 'Registrierung war erfolgreich.';
			}*/
		}
	}
}

if(defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/immoscout2ttnews/mod1/index.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/immoscout2ttnews/mod1/index.php']);
}

// Make instance:
$SOBE = t3lib_div::makeInstance('tx_immoscout2ttnews_module1');
$SOBE->init();
// Include files?
foreach($SOBE->include_once as $INC_FILE) {
	include_once($INC_FILE);
}
$SOBE->main();
?>