<?php
if (!defined('TYPO3_MODE')) {
	die('Access denied.');
}

$TCA['tx_t3basicext_record'] = array(
	'ctrl' => $TCA['tx_t3basicext_record']['ctrl'],
	'interface' => array(
		'showRecordFieldList' => 'hidden, starttime, endtime, fe_group, title, description, image, category'
	),
	'feInterface' => $TCA['tx_t3basicext_record']['feInterface'],
	'columns' => array(
		'title' => array(
			'exclude' => 1,
			'label'	=> 'LLL:EXT:t3basicext/locallang_db.xml:tx_t3basicext_record.title',
			'config' => array(
				'type' => 'input',
				'size' => 20,
				'eval' => 'required'
			)
		),
		'description' => array(
			'label' => 'LLL:EXT:t3basicext/locallang_db.xml:tx_t3basicext_record.description',
			'config' => array(
				'type' => 'text',
				'cols' => '30',
				'rows' => '4',
			)
		),
		'image' => array(
			'exclude' => 1,
			'l10n_mode' => 'exclude',
			'label' => 'LLL:EXT:lang/locallang_general.php:LGL.images',
			'config' => array(
				'type' => 'group',
				'internal_type' => 'file',
				'allowed' => $GLOBALS['TYPO3_CONF_VARS']['GFX']['imagefile_ext'],
				'max_size' => 10000,
				'uploadfolder' => 'uploads/tx_t3basicext',
				'show_thumbs' => 1,
				'size' => 1,
				'minitems' => 0,
				'maxitems' => 1
			)
		),
		'category' => array(
			'exclude' => 1,
			'l10n_mode' => 'exclude',
			'label' => 'LLL:EXT:t3basicext/locallang_db.xml:tx_t3basicext_record.category',
			'config' => array(
				'type' => 'select',
				'items' => array(
					array('LLL:EXT:t3basicext/locallang_db.xml:tx_t3basicext_record.category.1', 1),
					array('LLL:EXT:t3basicext/locallang_db.xml:tx_t3basicext_record.category.2', 2),
				),
				'size' => 3,
				'minitems' => 1,
				'maxitems' => 99
			)
		),
		// now the default fields
		'starttime' => Array (
			'exclude' => 1,
			'l10n_mode' => 'mergeIfNotBlank',
			'label' => 'LLL:EXT:lang/locallang_general.php:LGL.starttime',
			'config' => Array (
				'type' => 'input',
				'size' => '10',
				'max' => '20',
				'eval' => 'datetime',
				'checkbox' => '0',
				'default' => '0'
			)
		),
		'endtime' => Array (
			'exclude' => 1,
			'l10n_mode' => 'mergeIfNotBlank',
			'label' => 'LLL:EXT:lang/locallang_general.php:LGL.endtime',
			'config' => Array (
				'type' => 'input',
				'size' => '8',
				'max' => '20',
				'eval' => 'datetime',
				'checkbox' => '0',
				'default' => '0',
				'range' => Array (
					'upper' => mktime(0,0,0,12,31,2020),
					'lower' => mktime(0,0,0,date('m')-1,date('d'),date('Y'))
				)
			)
		),
		'hidden' => Array (
			'l10n_mode' => 'mergeIfNotBlank',
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.php:LGL.hidden',
			'config' => Array (
				'type' => 'check',
				'default' => '1'
			)
		),
		'fe_group' => array(
			'exclude' => 1,
			'l10n_mode' => 'mergeIfNotBlank',
			'label' => 'LLL:EXT:lang/locallang_general.php:LGL.fe_group',
			'config' => array(
				'type' => 'select',
				'size' => 5,
				'maxitems' => 20,
				'items' => array(
					array('LLL:EXT:lang/locallang_general.php:LGL.hide_at_login', -1),
					array('LLL:EXT:lang/locallang_general.php:LGL.any_login', -2),
					array('LLL:EXT:lang/locallang_general.php:LGL.usergroups', '--div--')
				),
				'exclusiveKeys' => '-1,-2',
				'foreign_table' => 'fe_groups'
			)
		),
		'sys_language_uid' => array(
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.php:LGL.language',
			'config' => array(
				'type' => 'select',
				'foreign_table' => 'sys_language',
				'foreign_table_where' => 'ORDER BY sys_language.title',
				'items' => array(
					array('LLL:EXT:lang/locallang_general.php:LGL.allLanguages',-1),
					array('LLL:EXT:lang/locallang_general.php:LGL.default_value',0)
				)
			)
		),
		'l18n_parent' => array(
			'displayCond' => 'FIELD:sys_language_uid:>:0',
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.php:LGL.l18n_parent',
			'config' => array(
				'type' => 'select',
				'items' => array(
					array('', 0),
				),
				'foreign_table' => 'tx_t3basicext_record',
				'foreign_table_where' => 'AND tx_t3basicext_record.uid=###REC_FIELD_l18n_parent### AND tx_t3basicext_record.sys_language_uid IN (-1,0)',
			)
		),
		'l18n_diffsource' => array(
			'config'=>array(
				'type'=>'passthrough'
			)
		),
		'sorting' => array(
			'l10n_mode' => 'exclude',
		),
	),
	'types' => array(
		'0' => array('showitem' => 'hidden;;1;;, title, descriptiondescription;;2;richtext:rte_transform[flag=rte_enabled|mode=ts];4-4-4, image, category')
	),
	'palettes' => array(
		'1' => array('showitem' => 'starttime, endtime, fe_group')
	)
);
?>